<?php
if(!defined('IN_DISCUZ')) {
	exit('Access Denied');
}
if($_GET['formhash'] != FORMHASH)
{
	exit('formhash is ERROR');
}
if (!isset($_G['cache']['plugin'])) {
	loadcache('plugin');
}
$zhiwu55_default=$_G['cache']['plugin']['zhiwu55com_autoreply']['zhiwu55_default'];
if(!empty($zhiwu55_default))
{
	$zhiwu55_default=trim($zhiwu55_default);
	$zhiwu55_defaultArr=preg_split('/[\r\n]+/',$zhiwu55_default);
}
if(!empty($zhiwu55_defaultArr) && is_array($zhiwu55_defaultArr))
{
	shuffle($zhiwu55_defaultArr);
	foreach($zhiwu55_defaultArr as $k=>$v)
	{
		$kk=$k+1;
		$zhiwu55_defaultArr['hzw'.$kk]=diconv($v,CHARSET,'UTF-8');
		unset($zhiwu55_defaultArr[$k]);
	}
}
if(empty($_GET['tid']) && empty($_GET['aid']))
{
	$zhiwu55_defaultArr['hzwcount']=count($zhiwu55_defaultArr);
	$zhiwu55_defaultArr['err']='tid OR aid ERROR';
	$returnData=json_encode($zhiwu55_defaultArr);
	echo $_GET['zhiwu55callback'] . '(' . $returnData . ')';
	exit;
}
require './source/plugin/zhiwu55com_autoreply/function_common.php';
$hzw_appid = wwwzhiwu55com_appid();
if(empty($_GET['keyword']) && !empty($_GET['tid']))
{
	$subject = DB::result_first('SELECT subject FROM %t WHERE tid=%d',array('forum_thread',$_GET['tid']));
	$subject = diconv($subject,CHARSET,'UTF-8');

}elseif(empty($_GET['keyword']) && !empty($_GET['aid'])) {

	$subject = DB::result_first('SELECT title FROM %t WHERE aid=%d',array('portal_article_title',$_GET['aid']));
	$subject = diconv($subject,CHARSET,'UTF-8');

} else {

	$subject = $_GET['keyword'];

}
$subject = preg_replace('/[^\x{4e00}-\x{9fa5}]/iu','',$subject);
$signArr=array();
$signArr['hzw_appid']=$hzw_appid;
if(empty($_G['cache']['plugin']['zhiwu55com_autoreply']['zhiwu55_appsecret']))
{
	$zhiwu55com_authorization_arr=array();
	if (!isset($_G['cache']['zhiwu55com_authorization'])) {
		loadcache('zhiwu55com_authorization');
	}
	if(!empty($_G['cache']['zhiwu55com_authorization']))
	{
		$zhiwu55com_authorization_arr = $_G['cache']['zhiwu55com_authorization'];
	}
	$signArr['appsecret']=$zhiwu55com_authorization_arr['hzw_appsecret'];

} else {

	$signArr['appsecret']=$_G['cache']['plugin']['zhiwu55com_autoreply']['zhiwu55_appsecret'];

}
if(empty($signArr['appsecret']))
{
	$zhiwu55_defaultArr['hzwcount']=count($zhiwu55_defaultArr);
	$zhiwu55_defaultArr['err']=lang('plugin/zhiwu55com_autoreply', 'zhiwu5comcn_10');
	$returnData=json_encode($zhiwu55_defaultArr);
	echo $_GET['zhiwu55callback'] . '(' . $returnData . ')';
	exit;
}
$signArr['keyword']=$subject;
$signArr['t']=time();
$sign=hzw_sign($signArr);
$dataUrl="http://www.zhiwu55.com/catch_data/zhiwu55com_autoreply.php?hzw_appid=".$hzw_appid.'&keyword='.urlencode($signArr['keyword']).'&t='.$signArr['t'].'&sign='.$sign;
$resultStr=dfsockopen($dataUrl);
$resultStr=trim($resultStr);
if($resultStr=='parameter_error') {

	$zhiwu55_defaultArr['hzwcount']=count($zhiwu55_defaultArr);
	$zhiwu55_defaultArr['err']=lang('plugin/zhiwu55com_autoreply', 'zhiwu5comcn_01');
	$zhiwu55_defaultArr['err']=diconv($zhiwu55_defaultArr['err'],CHARSET,'UTF-8');
	$returnData=json_encode($zhiwu55_defaultArr);
	echo $_GET['zhiwu55callback'] . '(' . $returnData . ')';
	exit;

} elseif($resultStr=='time_is_expire') {

	$zhiwu55_defaultArr['hzwcount']=count($zhiwu55_defaultArr);
	$zhiwu55_defaultArr['err']=lang('plugin/zhiwu55com_autoreply', 'zhiwu5comcn_02');
	$zhiwu55_defaultArr['err']=diconv($zhiwu55_defaultArr['err'],CHARSET,'UTF-8');
	$returnData=json_encode($zhiwu55_defaultArr);
	echo $_GET['zhiwu55callback'] . '(' . $returnData . ')';
	exit;

} elseif($resultStr=='hzw_appid_empty') {

	$zhiwu55_defaultArr['hzwcount']=count($zhiwu55_defaultArr);
	$zhiwu55_defaultArr['err']=lang('plugin/zhiwu55com_autoreply', 'zhiwu5comcn_03');
	$zhiwu55_defaultArr['err']=diconv($zhiwu55_defaultArr['err'],CHARSET,'UTF-8');
	$returnData=json_encode($zhiwu55_defaultArr);
	echo $_GET['zhiwu55callback'] . '(' . $returnData . ')';
	exit;

} elseif($resultStr=='frequently') {

	$zhiwu55_defaultArr['hzwcount']=count($zhiwu55_defaultArr);
	$zhiwu55_defaultArr['err']=lang('plugin/zhiwu55com_autoreply', 'zhiwu5comcn_04');
	$zhiwu55_defaultArr['err']=diconv($zhiwu55_defaultArr['err'],CHARSET,'UTF-8');
	$returnData=json_encode($zhiwu55_defaultArr);
	echo $_GET['zhiwu55callback'] . '(' . $returnData . ')';
	exit;

} elseif($resultStr=='sign_error') {

	$zhiwu55_defaultArr['hzwcount']=count($zhiwu55_defaultArr);
	$zhiwu55_defaultArr['err']=lang('plugin/zhiwu55com_autoreply', 'zhiwu5comcn_05');
	$zhiwu55_defaultArr['err']=diconv($zhiwu55_defaultArr['err'],CHARSET,'UTF-8');
	$returnData=json_encode($zhiwu55_defaultArr);
	echo $_GET['zhiwu55callback'] . '(' . $returnData . ')';
	exit;

} elseif(stripos($resultStr,'__zhiwu55.cn__')===false) {

	$zhiwu55_defaultArr['hzwcount']=count($zhiwu55_defaultArr);
	$zhiwu55_defaultArr['err']=lang('plugin/zhiwu55com_autoreply', 'zhiwu5comcn_06');
	$zhiwu55_defaultArr['err']=diconv($zhiwu55_defaultArr['err'],CHARSET,'UTF-8');
	$returnData=json_encode($zhiwu55_defaultArr);
	echo $_GET['zhiwu55callback'] . '(' . $returnData . ')';
	exit;

} elseif(strlen($resultStr)<20) {

	$zhiwu55_defaultArr['hzwcount']=count($zhiwu55_defaultArr);
	$zhiwu55_defaultArr['err']=lang('plugin/zhiwu55com_autoreply', 'zhiwu5comcn_06');
	$zhiwu55_defaultArr['err']=diconv($zhiwu55_defaultArr['err'],CHARSET,'UTF-8');
	$returnData=json_encode($zhiwu55_defaultArr);
	echo $_GET['zhiwu55callback'] . '(' . $returnData . ')';
	exit;

}
$commentArr=explode('__zhiwu55.cn__',$resultStr);
shuffle($commentArr);
$dataArr=array();
foreach($commentArr as $k=>$v)
{
	$kk=$k+1;
	$v=preg_replace('/\[.+?\]/','',$v);
	$v=str_replace('<br>',"\r\n",$v);
	$v=str_replace('</br>',"\r\n",$v);
	if(strlen($v)>3)
	{
		$dataArr['hzw'.$kk]=$v;
	}
}
$dataArr['hzwcount']=count($dataArr);
$returnData=json_encode($dataArr);
echo $_GET['zhiwu55callback'] . '(' . $returnData . ')';